#include "Moneta.h"
#include <iostream>
#include <string>
#include <iomanip>
#include <fstream>
#include <cmath>
using namespace std;

const char CFd1[] = "Duomenys.txt";
const char CFd2[] = "Duomenys2.txt";
const char CFrez[] = "Rezultatai.txt";
const int Cn = 100;
void Skaityti(const char Fd[], Moneta M[], int & n, string & pav);
void Spausdinti(ofstream & fr, Moneta M[], int n, string pav);
void SpausdintiLentel(ofstream & fr, Moneta M3[], int n3);
string SunkiausiaMoneta(Moneta M[], int n);
double BendraVert(Moneta M[], int n);
int DidiausiasNominalas(Moneta M[], int n);
int Turtingiausias(Moneta M[], int n);
int kiekYra (Moneta M1[], int n1, Moneta M2[], int n2);
void Formuoti(Moneta M1[], int n1, Moneta M2[], int n2, Moneta M3[], int & n3);


int main () 
{
	setlocale(LC_ALL, "Lithuanian");
	Moneta M1[Cn]; // Pirmojo kolekcininko monet duomenys
	string pav1; //kolekcininko vardas ir pavard
	int n1 = 0;// monet skaiius
	Moneta M2[Cn]; // Antrojo kolekcininko monet duomenys
	string pav2; // kolekcininko vardas ir pavard
	int n2 = 0; // monet skaiius
	Moneta M3[Cn]; //Monet, kuri nominalas 1, duomenys
	int n3 = 0; // monet skaiius
	ofstream fr(CFrez);
	Skaityti(CFd1, M1, n1, pav1);
	Skaityti(CFd2, M2, n2, pav2);
	Spausdinti(fr, M1, n1, pav1);
	Spausdinti(fr, M2, n2, pav2);
	if (M1[Turtingiausias(M1, n1)].ImtiNominal() < M2[Turtingiausias(M2, n2)].ImtiNominal())
		fr << "Turtingiausias kolekcionierius: " << pav1 << endl;
	else 
		fr << "Turtingiausias kolekcionierius: " << pav2 << endl;
	Formuoti(M1, n1, M2, n2, M3, n3);
	SpausdintiLentel(fr, M3, n3);
	fr.close();
	return 0;
	
}

void Skaityti(const char Fd[], Moneta M[], int & n, string & pav)
{
	string alis;
	int nominalas;
	double svoris;
	ifstream fd(Fd);
	getline(fd, pav);
	fd >> n;
	for (int i = 0; i < n; i++)
	{
		fd >> alis >> nominalas >> svoris;
		M[i].Dti(alis, nominalas, svoris);
	}
	fd.close();
}

void Spausdinti(ofstream & fr, Moneta M[], int n, string pav)
{
	fr << "Kolekcininkas: " << pav << endl;
	fr << "Monet skaiius: " << n <<  endl;
	fr << "--------------------------------------------\n";
	fr << "| Nr.| Kilms alis | Nominalas | Svoris (g)|\n";
	fr << "--------------------------------------------\n";
	for ( int i = 0; i < n; i++)
	fr << "| " << setw(3) << left << i + 1 << "| " << setw(11) << left << M[i].Imtial() << " | "
	<< setw(9) << M[i].ImtiNominal() << " | "
	<< setw(9) << M[i].ImtiSvor() << " |" << endl;
	fr << "--------------------------------------------\n";
	fr << "Sunkiausia moneta: " << SunkiausiaMoneta(M, n) << endl;
	fr << "Bendra monet pinigin vert: " << BendraVert(M, n) << endl;
}

void SpausdintiLentel(ofstream & fr, Moneta M3[], int n3)
{
	fr << "--------------------------------------------\n";
	fr << "Tinkam monet sraas: " << endl;
	fr << "--------------------------------------------\n";
	fr << "| Nr.| Kilms alis | Nominalas | Svoris(g)|\n";
	fr << "--------------------------------------------\n";
	for ( int i = 0; i < n3; i++)
	fr << "| " << setw(3) << left << i + 1 << "| " << setw(11) << left << M3[i].Imtial() << " | "
	<< setw(9) << M3[i].ImtiNominal() << " | "
	<< setw(9) << M3[i].ImtiSvor() << " |" << endl;
	fr << "--------------------------------------------\n";
}

string SunkiausiaMoneta(Moneta M[], int n)
{
	string k;
	double max = M[0].ImtiSvor();
	for (int i = 0; i < n; i++)
		if(M[i].ImtiSvor() > max){
			k = M[i].Imtial();
		}
		return k;
}

double BendraVert(Moneta M[], int n)
{
	double suma = 0;
	for (int i = 0; i < n; i++){
		suma += M[i].ImtiNominal();
		}
 return suma;
}

int DidiausiasNominalas(Moneta M[], int n)
{
	int k;
	double max = M[0].ImtiNominal();
	for (int i = 0; i < n; i++)
		if (M[i].ImtiNominal() > max){
			k = M[i].ImtiNominal();
		}
	return k;
}

int Turtingiausias(Moneta M[], int n)
{
	int suma = 0;
	for (int i = 0; i < n; i++)
	suma += M[i].ImtiNominal();
	return suma;
}

int kiekYra (Moneta M1[], int n1, Moneta M2[], int n2)
{
	int skaiius = 0;
	for (int i = 0; i < n1; i++)
	if (M1[i].ImtiNominal() == 1)
	for (int i = 0; i < n2; i++)
	if (M2[i].ImtiNominal() == 1)
	skaiius++;
	return skaiius;
}

void Formuoti(Moneta M1[], int n1, Moneta M2[], int n2, Moneta M3[], int & n3)
{
	for (int i = 0; i < n1; i++)
	if (M1[i].ImtiNominal() == 1) {
		M3[n3] = M1[i];	
		n3++;
	}
	for (int i = 0; i < n2; i++)
	if (M2[i].ImtiNominal() == 1) {
		M3[n3] = M2[i];	
		n3++;
	}
}